<?php
/********************
* mirror_admin.php
* administration script for managing
* mirrors and files
* @author Quad341
* created: 2005-03-29
*********************/
$self = $_SERVER[PHP_SELF];
require_once "mirror_config.php";
require_once "mirror_functions.php";
session_start();




// the following is for the mime_content_type() function
// it is the original php source.  see this original file
// with liscense at http://www.powertrip.co.za/pearhost/HTTP_UploadManager/UploadManager.phps

/*
* `mime_content_type' function is the same as defined within `mime.magic' module.
*
* @param  string  $filename  File name for define of mime-type
* @return string  Mime-type  of uploaded file.
*         This function only emulates behaviour of the original function
*         defined by `mime.magic' module.
*/
if (!function_exists("mime_content_type")) {

    function mime_content_type($filename)
    {
        $mime_types = @file("mime.types");
        foreach ($mime_types as $m) {
            $m = trim($m);
            if ($m == "" || $m[0] == "#") continue;
            if (!preg_match('/(.*?)?\s+(.*)/', $m, $x)) continue;
            foreach (explode(" ", $x[2]) as $e)
                if (preg_match("/\.$e$/i", $filename)) return $x[1];
        }
        return "text/plain";
    }

} 





if ($_SESSION[login_term]=="allowed"){
	// logged in, show everything/allow access
	
	// we need to determine where the admin wants to be.
	// we'll use get variables to sort this better.  it will be logical then
	// and easier to read
	if ($_GET[section]=="mirrors"){
		// this section is all about mirror administration
		if ($_GET[action]=="add"){
			// add a new mirror to the database
			$body = <<<EOP
			<a href="$self">Index</a> \ <a href="$self?section=mirrors">Mirrors</a><br>
			<br>
			Here you may add a mirror to the database to be used when requesting downloads.<br>
			Currently, mirrors must host the file with the same name.<br>
			TODO: Do something for indirect links<br>
			<br><br>
			Complete the form and click submit to add the mirror:<br>
			<br>
			<form action="$self?section=mirrors" method="post">
			<input type="hidden" name="action" value="new">
			Mirror Name (for reference.  mentioned when used. ie. "File hosting provided by [MIRROR NAME]")<br>
			<input type="text" name="mir_name"><br>
			<br>
			Base URL (file  names are added immediately after this.  this is the directory where the files are kept. ie. "http://quad341.com/files/".  requries trailing /)<br>
			<input type="text" name="base_url"><br>
			<br>
			Bandwidth Limit (amount of bandwidth the mirror allocated.  Use an insanely high number if unlimited.  max ~ 1,000,000,000 terabytes)<br>
			Put number in left and select unit on right:<br>
			<input type="text" name="bw_limit"> <select name="bw_type">
			<option value="0">B (Bytes)</option>
			<option value="1">KB (KiloBytes)</option>
			<option value="2">MB (MegaBytes)</option>
			<option value="3" checked>GB (GigaBytes)</option>
			<option value="4">TB (TeraBytes)</option>
			</select><br>
			<input type="submit" name="submit" value="Submit">
			</form>
EOP;
		} elseif($_POST[action]=="new"){
			// add entry to mirror database.
			// set variables
			$mirror_name = $_POST[mir_name];
			$base_url = $_POST[base_url];
			$limit_num = $_POST[bw_limit];
			$pow = $_POST[bw_type];
			// because of the different units, we need to multiply
			// if you noticed, i called it pow (like power for exponents)
			// that's because we can multiply by 1024^$pow to find the bytes
			$bw_limit = $limit_num * pow(1024,$pow);
			
			// now insert
			$mir_table = $table_prefix . "mirrors";
			$mir_ins_query = "INSERT INTO `$mir_table` (`base_url`,`name`,`max_bw`) VALUES ('$base_url','$mirror_name','$bw_limit')";
			$mir_ins_result = mysql_query($mir_ins_query);
			if ($mir_ins_result){
				$body = "<a href=\"$self\">Index</a><br><br>Mirror successfully added.";
			} else {
				$body = "Error: ".mysql_error();
			}
		} elseif ($_GET[action]=="edit"){
			// edit entry
			$id = $_GET[id];
			// select information
			$mirror_table = $table_prefix . "mirrors";
			$sel_query = "SELECT * FROM `$mirror_table` WHERE `id`='$id'";
			$sel_result = mysql_query($sel_query);
			if(mysql_num_rows($sel_result)<1){
				// no entry by that id
				$body = "<a href=\"$self\">Index</a><br><br>There is no entry by that id.";
			} else {
				// it's good! take advantage of php's lack of real scoping
				while($sel_array = mysql_fetch_array($sel_result)){
					$base_url = $sel_array[base_url];
					$name = $sel_array[name];
					$max_bw = $sel_array[max_bw];
				}
				// let's do some converting since i doubt they entered this in bytes
				$k_bw = $max_bw/1024;
				$m_bw = $k_bw/1024;
				$g_bw = $m_bw/1024;
				$t_bw = $g_bw/1024;
				
				// display
				$body = <<<EOP
				<a href="$self">Index</a> / <a href="$self?section=mirrors&id=$id">Editing $name</a>
				<br><br><br><br>
				Current settings:<br>
				Name: $name<br>
				Base Url: <a href="$base_url">$base_url</a><br>
				<dl><dt>Bandwidth Limit</dt>
				<dd>
				<ul>
				<li>Bytes: $max_bw B</li>
				<li>KiloBytes: $k_bw KB</li>
				<li>MegaBytes: $m_bw MB</li>
				<li>GigaBytes: $b_bw GB</li>
				<li>TeraBytes: $t_bw TB</li>
				</ul>
				</dd>
				<br><br>
				Edit below:<br>
				<br>
				<form action="$self?section=mirrors" method="post">
				<input type="hidden" name="action" value="update">
				<input type="hidden" name="id" value="$id">
				Mirror Name (for reference.  mentioned when used. ie. "File hosting provided by [MIRROR NAME]")<br>
				<input type="text" name="mir_name" value="$name"><br>
				<br>
				Base URL (file  names are added immediately after this.  this is the directory where the files are kept. ie. "http://quad341.com/files/".  requries trailing /)<br>
				<input type="text" name="base_url" value="$base_url"><br>
				<br>
				Bandwidth Limit (amount of bandwidth the mirror allocated.  Use an insanely high number if unlimited.  max ~ 1,000,000,000 terabytes)<br>
				Put number in left and select unit on right:<br>
				<input type="text" name="bw_limit" value="$g_bw"> <select name="bw_type">
				<option value="0">B (Bytes)</option>
				<option value="1">KB (KiloBytes)</option>
				<option value="2">MB (MegaBytes)</option>
				<option value="3" checked>GB (GigaBytes)</option>
				<option value="4">TB (TeraBytes)</option>
				</select><br>
				<input type="submit" name="submit" value="Submit">
				</form>
EOP;
			}
		} elseif ($_POST[action]=="update"){
			// update the database based upon the changes
			// set variables
			$id = $_POST[id];
			$mirror_name = $_POST[mir_name];
			$base_url = $_POST[base_url];
			$limit_num = $_POST[bw_limit];
			$pow = $_POST[bw_type];
			// because of the different units, we need to multiply
			// if you noticed, i called it pow (like power for exponents)
			// that's because we can multiply by 1024^$pow to find the bytes
			$bw_limit = $limit_num * pow(1024,$pow);
			
			// now update
			$mir_table = $table_prefix . "mirrors";
			$update_query = "UPDATE `$mir_table` SET `base_url`='$base_url',`name`='$mirror_name',`max_bw`='$bw_limit' WHERE `id`='$id'";
			$update_result = mysql_query($update_query);
			if ($update_result){
				$body = "<a href=\"$self\">Index</a><br><br>$mirror_name successfully updated.";
			} else {
				$body = "Error: ".mysql_error();
			}
		} elseif ($_GET[action]=="delete"){
			// this deletes.  prompting is a waste.  it's hard to accidentally hit
			$id = $_GET[id];
			// delete
			$mir_table = $table_prefix . "mirrors";
			$del_query = "DELETE FROM `$mir_table` WHERE `id`='$id'";
			$del_result = mysql_query($del_query);
			if ($del_result){
				$body = "<a href=\"$self\">Index</a><br><br>Entry successfully deleted.";
			} else {
				$body = "Error: ".mysql_error();
			}
		} else {
			// default.  lists all mirrors with edit and delete links
			// first check to see if there are any current mirrors.  if not,  don't make the table
			$mir_table = $table_prefix . "mirrors";
			$all_sel_query = "SELECT * FROM `$mir_table` WHERE 1";
			$all_sel_result = mysql_query($all_sel_query);
			if (mysql_num_rows($all_sel_result)<1){
				// no entries!
				$table = "<br><strong>No mirrors in database</strong><br>";
			} else {
				// there is at least one entry.
				// define the table and the headings row
				
				// TODO: display current bw usage here
				$table_header = <<<EOTH
				<br>
				<table width="200px" cellspacing="1" cellpadding="1" border="1">
				<th>Mirror Name</th><th>Bandwidth Limit</th><th>Edit</th><th>Delete</th>
EOTH;
				// now loop and populate the table.  each row is one db row
				while ($row_array = mysql_fetch_array($all_sel_result)){
					$id = $row_array[id];
					$name = $row_array[name];
					$base_url = $row_array[base_url];
					$bw_limit = $row_array[max_bw];
					// the following lines actually makes the row
					$rows .= <<<EOR
					<tr>
					<td><a href="$base_url">$name</a></td>
					<td>$bw_limit</td>
					<td><a href="$self?section=mirrors&action=edit&id=$id">Edit</a></td>
					<td><a href="$self?section=mirrors&action=delete&id=$id">Delete</a></td>
					</tr>
EOR;
				}
				$table_footer = "</table><br>";
				// put the table together
				$table = $table_header . $rows . $table_footer;
			}
			// construct the page
			$body = <<<EOP
			<a href="$self">Index</a><br><br><br><br>
			Welcome to the administration section for mirrors.<br>
			<a href="$self?section=mirrors&action=add">Click Here to add a new mirror</a>.<br>
			<br>
			Below is a list of the current mirrors:<br>
			<br>
			$table
EOP;
		}
	} elseif($_GET[section]=="files"){
		// this section is all about file administration
		if ($_GET[action]=="new"){
			// add a new file entry
			$body = <<<EOP
			<a href="$self">Index</a><br><br><br><br>
			Fill out the form below and click submit to add the file entry.<br>
			<br>
			<form action="$self?section=files" method="post">
			<input type="hidden" name="action" value="add">
			File Name (will be displayed)<br>
			<input type="text" name="filename"><br>
			<br>
			File Size (the size in bytes of the file. The script can determine this if the file is uploaded to this server):<br>
			<table width="30%" border="0" cellspacing="0" cellpadding="1">
			<tr>
			<td valign="top"><input type="radio" name="size_type" value="manual" checked> <input type="text" name="file_size"></td>
			<td valign="top">Enter the size manually (in bytes).  If the size is not exact, this might cause a server to be used more
			or less that it could be if accurately entered, but it still will work.</td>
			</tr>
			<tr>
			<td valign="top"><input type="radio" name="size_type" value="auto"> <input type="text" name="filepath"></td>
			<td valign="top">Enter the path (reletive or absolute) to the file on the server.  This scirpt will then determine
			the filesize and enter it for you (reccomended).  Example of the path: this script is http://site.com/mirrors/[this].
			the download is http://site.com/files/[filename].  the path would be (no quotes) \"../files/[filename]\"</td>
			</table>
			<br>
			<br>
			<input type="submit" name="submit" value="Submit">
			</form>
EOP;
		} elseif($_POST[action]=="add"){
			// add the file to the database
			$filename = $_POST[filename];
			if ($_POST[size_type]=="manual"){
				$filesize=$_POST[file_size];
			} else {
				$filesize=filesize($_POST[filepath]);
			}
			// insert
			$files_table = $table_prefix . "files";
			$ins_query = "INSERT INTO `$files_table` (`filename`,`file_size`) VALUES ('$filename','$filesize')";
			$ins_result = mysql_query($ins_query);
			if ($ins_result){
				// it was successful, but we need to know that id number
				// so we can tell them what the link is
				$sel_query = "SELECT `id` FROM `$files_table` WHERE `filename`='$filename' AND `file_size`='$filesize'";
				$sel_result = mysql_query($sel_query);
				while($row = mysql_fetch_row($sel_result)){
					$id=$row[0];
				}
				$body = "<a href=\"$self\">Index</a><br><br><br><br>
				File entry successfully added.<br>
				The link to download is <strong>mirror_download.php?id=$id</strong><br>
				assuming the download script is still mirror_download.php.";
			} else {
				$body = "Error: ".mysql_error();
			}
		} elseif ($_GET[action]=="edit"){
			// edit an entry
			$id = $_GET[id];
			// select information
			$file_table = $table_prefix . "files";
			$sel_query = "SELECT * FROM `$file_table` WHERE `id`='$id'";
			$sel_result = mysql_query($sel_query);
			if(mysql_num_rows($sel_result)<1){
				// no entry by that id
				$body = "<a href=\"$self\">Index</a><br><br>There is no entry by that id.";
			} else {
				// it's good! take advantage of php's lack of real scoping
				while($sel_array = mysql_fetch_array($sel_result)){
					$filename = $sel_array[filename];
					$filesize = $sel_array[file_size];
				}
				// display and allow editting
				$body = <<<EOP
				<a href="$self">Index</a><br><br><br><br>
				Current settings:<br>
				File Name: $filename<br>
				File Size: $filesize B<br>
				<br>
				<br>
				<br>
				Edit the form below to update this entry:<br>
				<br>
				<form action="$self?section=files" method="post">
				<input type="hidden" name="action" value="update">
				<input type="hidden" name="id" value="$id">
				File Name (will be displayed)<br>
				<input type="text" name="filename" value="$filename"><br>
				<br>
				File Size (the size in bytes of the file. The script can determine this if the file is uploaded to this server):<br>
				<table width="30%" border="0" cellspacing="0" cellpadding="1">
				<tr>
				<td valign="top"><input type="radio" name="size_type" value="manual" checked> <input type="text" name="file_size" value="$filesize"></td>
				<td valign="top">Enter the size manually (in bytes).  If the size is not exact, this might cause a server to be used more
				or less that it could be if accurately entered, but it still will work.</td>
				</tr>
				<tr>
				<td valign="top"><input type="radio" name="size_type" value="auto"> <input type="text" name="filepath"></td>
				<td valign="top">Enter the path (reletive or absolute) to the file on the server.  This scirpt will then determine
				the filesize and enter it for you (reccomended).  Example of the path: this script is http://site.com/mirrors/[this].
				the download is http://site.com/files/[filename].  the path would be (no quotes) "../files/[filename]"</td>
				</table>
				<br>
				<br>
				<input type="submit" name="submit" value="Submit">
				</form>
EOP;
			}
		} elseif ($_POST[action]=="update"){
			// update an entry
			$id = $_POST[id];
			$filename = $_POST[filename];
			if ($_POST[size_type]=="manual"){
				$filesize=$_POST[file_size];
			} else {
				$filesize=filesize($_POST[filepath]);
			}
			// update
			$files_table = $table_prefix . "files";
			$upd_query = "UPDATE `$files_table` SET `filename`='$filename',`file_size`='$filesize' WHERE `id`='$id'";
			$upd_result = mysql_query($upd_query);
			if ($upd_result){
				// updated successfully
				$body ="<a href=\"$self\">Index</a><br><br><br><br>
				The link to download is <strong>mirror_download.php?id=$id</strong><br>
				assuming the download script is still mirror_download.php.";
			} else {
				$body = "Error: ".mysql_error();
			}
		} elseif($_GET[action]=="delete"){
			// delete the entry.  no prompt
			$id = $_GET[id];
			// delete
			$files_table = $table_prefix . "files";
			$del_query = "DELETE FROM `$files_table` WHERE `id`='$id'";
			$del_result = mysql_query($del_query);
			if ($del_result){
				$body = "<a href=\"$self\">Index</a><br><br><br><br>
				Entry successfully deleted.";
			} else {
				$body = "Error: ".mysql_error();
			}
		} else {
			// default, display all
			
			// check if any entries first.  don't display a table if not
			$file_table = $table_prefix . "files";
			$all_sel_query = "SELECT * FROM `$file_table` WHERE 1";
			$all_sel_result = mysql_query($all_sel_query);
			if (mysql_num_rows($all_sel_result)<1){
				// no entries!
				$table = "<br><strong>No files in database</strong><br>";
			} else {
				// there is at least one entry.
				// define the table and the headings row
				
				// TODO: display current bw usage here
				$table_header = <<<EOTH
				<br>
				<table width="200px" cellspacing="1" cellpadding="1" border="1">
				<th>File Name</th><th>File Size</th><th>Edit</th><th>Delete</th>
EOTH;
				// now loop and populate the table.  each row is one db row
				while ($row_array = mysql_fetch_array($all_sel_result)){
					$id = $row_array[id];
					$filename = $row_array[filename];
					$filesize = $row_array[file_size];
					// the following lines actually makes the row
					$rows .= <<<EOR
					<tr>
					<td>$filename</a></td>
					<td>$filesize</td>
					<td><a href="$self?section=files&action=edit&id=$id">Edit</a></td>
					<td><a href="$self?section=files&action=delete&id=$id">Delete</a></td>
					</tr>
EOR;
				}
				$table_footer = "</table><br>";
				// put the table together
				$table = $table_header . $rows . $table_footer;
			}
			// construct the page
			$body = <<<EOP
			<a href="$self">Index</a><br><br><br><br>
			Welcome to the administration section for files.<br>
			<a href="$self?section=files&action=new">Click Here to add a new file entry</a>.<br>
			<br>
			Below is a list of the current files:<br>
			<br>
			$table
EOP;
		}
	} elseif($_GET[section]=="config"){
		// configure the settings for the mirror system
		// only can edit them and update them really.  this is easier
		if (isset($_POST[submit])){
			
			// update the values
			if($_POST[admin_pass]!="" && $_POST[admin_pass]==$_POST[admin_pass2]){
				$update_pass=true;
				$pass=$_POST['admin_pass'];
			} else {
				$update_pass=false;
			}
			$admin_name = $_POST[admin_name];
			$display_list = $_POST[display_list];
			$leave_uploaded = $_POST[leave_uploaded];
			$upload_dir = $_POST[upload_dir];
			$display_files=$_POST[display_files];
			// open the config file, read all of it
			$fr=fopen("mirror_config.php",'r');
			$file=fread($fr,filesize("mirror_config.php"));
			// we need to open the file for writing, so close this stream
			fclose($fr);
			
			// find the index of the variables.  copy all that's before them and after the line
			// edit the line and put back together.  repeat till all variable have been updated
			$admin_name_index = strpos($file,'$ADMIN_LOGIN');
			$admin_name_newline = strpos($file,"\n",$admin_name_index);
			$file_beginning = substr($file,0,$admin_name_index);
			$file_end = substr($file,$admin_name_newline+2,strlen($file)-$admin_name_newline-2);
			$file = $file_beginning . "\$ADMIN_LOGIN=\"$admin_name\";\n" . $file_end;
			
			$display_list_index = strpos($file,'$display_list');
			$display_list_newline = strpos($file,"\n",$display_list_index);
			$file_beginning = substr($file,0,$display_list_index);
			$file_end = substr($file,$display_list_newline+2,strlen($file)-$display_list_newline-2);
			$file = $file_beginning . "\$display_list=$display_list;\n" . $file_end;
			
			$leave_uploaded_index = strpos($file,'$leave_uploaded_file');
			$leave_uploaded_newline = strpos($file,"\n",$leave_uploaded_index);
			$file_beginning = substr($file,0,$leave_uploaded_index);
			$file_end = substr($file,$leave_uploaded_newline+2,strlen($file)-$leave_uploaded_newline-2);
			$file = $file_beginning . "\$leave_uploaded_file=$leave_uploaded;\n" . $file_end;
			
			$upload_dir_index = strpos($file,'$uploaded_file_dir');
			$upload_dir_newline = strpos($file,"\n",$upload_dir_index);
			$file_beginning = substr($file,0,$upload_dir_index);
			$file_end = substr($file,$upload_dir_newline+2,strlen($file)-$upload_dir_newline-2);
			$file = $file_beginning . "\$uploaded_file_dir=$upload_dir;\n" . $file_end;
			
			$display_files_index = strpos($file,'$show_file_list');
			$display_files_newline = strpos($file,"\n",$display_files_index);
			$file_beginning = substr($file,0,$display_files_index);
			$file_end = substr($file,$display_files_newline+2,strlen($file)-$display_files_newline-2);
			$file = $file_beginning . "\$show_files_list=$display_files;\n" . $file_end;
			
			if ($update_pass){
				$admin_pass_index = strpos($file,'$ADMIN_PASSWORD');
				$admin_pass_newline = strpos($file,"\n",$admin_pass_index);
				$file_beginning = substr($file,0,$admin_pass_index);
				$file_end = substr($file,$admin_pass_newline+2,strlen($file)-$admin_pass_newline-2);
				$file = $file_beginning . "\$ADMIN_PASSWORD=\"$pass\";\n" . $file_end;
			}
			
			// open file and write to it
			$fw = fopen('mirror_config.php','w');
			if(fwrite($fw,$file)){
				$body = "<a href=\"$self\">Index</a><br><br><br><br>
					Settings successfully updated.";
			} else {
				$body = "There was an error accessing mirror_confing.php.  Ensure the file is writable.";
			}
			fclose($fw);
			
			
		} else {
			//display and allow update
			if ($show_mirrors_list==true){
				$y_checked="checked";
				$n_checked="";
			} else {
				$y_checked="";
				$n_checked="";
			}
			if ($leave_uploaded_file==true){
				$uf_y_checked="checked";
				$uf_n_checked="";
			} else {
				$uf_y_checked="";
				$uf_n_checked="checked";
			}
			if ($show_file_list==true){
				$sf_y_checked="checked";
				$sf_n_checked="";
			} else {
				$sf_y_checked="";
				$sf_n_checked="";
			}
			$body = <<<EOP
			<a href="$self">Index</a><br><br><br><br>
			Edit the settings below and click submit to update.<br>
			Leave the password spaces blank to leave it.  All other blanks
			are updated regardless.<br>
			<br>
			<form action="$self?section=config" method="post">
			Change Admin Username (for logins):<br>
			<input type="text" name="admin_name" value="$ADMIN_LOGIN"><br>
			<br>
			Change Admin Password (leave blank to leave the same):<br>
			<input type="password" name="admin_pass"><br>
			<br>
			Confirm Admin Password (only to change):<br>
			<input type="password" name="admin_pass2"><br>
			<br>
			Display a list of mirrors on download page?<br>
			<blockquote>
				<input type="radio" name="display_list" value="true" $y_checked> Yes<br>
				<input type="radio" name="display_list" value="false" $n_checked> No<br>
			</blockquote>
			<br>
			Leave Uploaded files (to be syncronized) on the server?<br>
			NOTE: You still have to add your site to the mirrors list for it to serve the file regardless of this setting<br>
			<blockquote>
				<input type="radio" name="leave_uploaded" value="true" $uf_y_checked> Yes<br>
				<input type="radio" name="leave_uploaded" value="false" $uf_n_checked> No<br>
			</blockquote>
			<br>
			If yes, what directory (with trailing /) do you want the files in (reletive or absolute, MUST HAVE WRITE ACCESS):<br>
			<input type="text" name="upload_dir" value="$uploaded_file_dir"><br>
			<br>
			Show list of files if no id is specified?<br>
			<blockquote>
				<input type="radio" name="display_files" value="true" $sf_y_checked> Yes<br>
				<input type="radio" name="display_files" value="false" $sf_n_checked> No<br>
			</blockquote>
			<br>
			<input type="submit" name="submit" value="Submit">
			</form>
EOP;
		}
	} elseif($_GET[section]=="syncronize"){
		// section for setting up syncronization settings for mirrors
		
		// note:  it is not required for a server that you syncronize to to
		// also be a mirror.  you can use this fact to help backup mirrored files
		// or something like that
		if($_GET[action]=="new_server"){
			// display form to add a new sync server
			$body = <<<EOP
			<a href="$self">Index</a><br><br><br><br>
			Fill out the following form and click submit to add the entry.<br>
			<br>
			<form action="$self?section=syncronize" method="post">
			<input type="hidden" name="action" value="add_server">
			URL to host of mirror (ie. http://site.com):<br>
			NOTE: for Post Script, this is the hostname only, ie: http://site.com<br>
			<input type="text" name="sync_host"><br>
			<br>
			Sycronization Method:<br>
			<select name="sync_type">
			<option value="1">FTP</option>
			<option value="2">Post Script</option>
			</select><br>
			<br>
			Server Login:<br>
			<input type="text" name="sync_login"><br>
			<br>
			Server Password:<br>
			<input type="password" name="sync_pass"><br>
			<br>
			Directory on Server<br>
			NOTE: this is to the directory to place the file for ftp* or to the script** for Post Script<br>
			(*this is the directory including the document folder where to upload the file to. ie. "httpdocs/files/"):<br>
			(**this is from the host to the script file. ie. script is at http://site.com/script.php.  the hostname (above) is http://site.com and this directory is /script.php)<br>
			<input type="text" name="sync_dir"><br>
			<br>
			<input type="submit" name="submit" value="Submit">
			</form>
EOP;
		} elseif ($_POST[action]=="add_server"){
			// add entry to database
			// get vars into better vars
			foreach ($_POST as $key => $val){
				${$key}=$val;
			}
			
			$sync_table = $table_prefix . "sync";
			$add_sync_query = "INSERT INTO `$sync_table` (`sync_type`,`sync_host`,`sync_login`,`sync_pass`,`sync_dir`) VALUES ('$sync_type','$sync_host','$sync_login','$sync_pass','$sync_dir')";
			$add_sync_result = mysql_query($add_sync_query);
			if ($add_sync_result){
				$body = "<a href=\"$self\">Index</a><br><br><br><Br>
				Entry successfully added";
			} else {
				$body = "Error: ".mysql_error();
			}
		} elseif($_GET[action]=="edit_server"){
			// edit the server entry
			$id = $_GET[id];
			$sync_table = $table_prefix . "sync";
			$sel_query = "SELECT * FROM `$sync_table` WHERE `id`='$id'";
			$sel_result = mysql_query($sel_query);
			while($sel_array = mysql_fetch_array($sel_result)){
				$sync_type=$sel_array[sync_type];
				$sync_host = $sel_array[sync_host];
				$sync_login = $sel_array[sync_login];
				$sync_pass = $sel_array[sync_pass];
				$sync_dir = $sel_array[sync_dir];
			}
			switch ($sync_type){
				case 1:
					$type = "FTP Access";
					break;
				case 2:
					$type = "Helper Script";
					break;
			}
			
			$body = <<<EOP
			<a href="$self">Index</a><br><br><br><br>
			The current settings are as follows:<br>
			<br>
			Sync Type: $type
			Host: <a href="$sync_host">$sync_host</a><br>
			Login: $sync_login<br>
			Password: [hidden]<br>
			Directory: $sync_dir<br>
			<br>
					
			Fill out the following form and click submit to edit the entry.<br>
			<strong>MAKE SURE SYNC TYPE IS CORRECT</strong><br>
			<br>
			<form action="$self?section=syncronize" method="post">
			<input type="hidden" name="id" value="$id">
			<input type="hidden" name="action" value="update_server">
			URL to host of mirror (ie. ftp://site.com):<br>
			NOTE: for Post Script, this is the hostname only, ie: http://site.com<br>
			<input type="text" name="sync_host" value="$sync_host"><br>
			<br>
			Sycronization Method:<br>
			<select name="sync_type">
			<option value="1">FTP</option>
			<option value="2">Post Script</option>
			</select><br>
			<br>
			Server Login:<br>
			<input type="text" name="sync_login" value="$sync_login"><br>
			<br>
			Server Password:<br>
			<input type="password" name="sync_pass" value="$sync_pass"><br>
			<br>
			Directory on Server<br>
			NOTE: this is to the directory to place the file for ftp* or to the script** for Post Script<br>
			(*this is the directory including the document folder where to upload the file to. ie. "httpdocs/files/"):<br>
			(**this is from the host to the script file. ie. script is at http://site.com/script.php.  the hostname (above) is http://site.com and this directory is /script.php)<br>
			<input type="text" name="sync_dir" value="$sync_dir"><br>
			<br>
			<input type="submit" name="submit" value="Submit">
			</form>
EOP;
		} elseif ($_POST[action]=="update_server"){
			// update server entry
			// variables
			foreach ($_POST as $key => $val){
				${$key}=$val;
			}
			$sync_table = $table_prefix . "sync";
			$update_query = "UPDATE `$sync_table` SET `sync_type`='$sync_type',`sync_host`='$sync_host',`sync_login`='$sync_login',`sync_pass`='$sync_pass',`sync_dir`='$sync_dir' WHERE `id`='$id'";
			$update_result = mysql_query($update_query);
			if ($update_result){
				$body = "<a href=\"$self\">Index</a><br><br><br><br>
				Entry successfully updated.";
			} else {
				$body = "Error: ".mysql_error();
			}
		} elseif ($_GET[action]=="del_server"){
			// delete server from database
			$id = $_GET[id];
			$sync_table = $table_prefix."sync";
			$del_query = "DELETE FROM `$sync_table` WHERE `id`='$id'";
			$del_result=mysql_query($del_query);
			if($del_result){
				$body = "<a href=\"$self\">Index</a><br><br><br><br>
				Entry successfully deleted.";
			} else {
				$body = "Error: ".mysql_error();
			}
		} elseif($_GET[action]=="add_file"){
			// to upload a file
			// show form
			$body = <<<EOP
			<a href="$self">Index</a><br><br><br><br>
			Fill out the form below and click submit to upload and syncronize a file.<br>
			<br>
			<form action="$self?section=syncronize" method="post" enctype="multipart/form-data">
			<input type="hidden" name="action" value="sync_file">
			File:<br>
			<input type="file" name="file"><br>
			<br>
			New file name INCLUDING EXTENSION(what file will be stored as)<br>
			NOTE: leave blank to use the filename of the file on your computer:<br>
			<input type="text" name="filename"><br>
			<br>
			<input type="submit" name="submit" value="submit">
			</form>
EOP;
		} elseif($_POST[action]=="sync_file"){
			// to actually transfer the files to the mirrors
			// let's get variables first
			if($_POST[filename]==""){
				$filename=$_FILES[file][name];
			} else {
				$filename=$_POST[filename];
			}
			$local_file = $_FILES[file][tmp_name];
			//initializing $body so output is complete
			$body = "<a href=\"$self\">Index</a><br><br><br><br>";
			if($leave_uploaded_file){
				// first let's move this to it's local postion if that's set up to do so
				if(move_uploaded_file($local_file,$uploaded_file_dir.$filename)){
					$body .= "File successfully moved to local directory $uploaded_file_dir<br>";
					$local_file=$uploaded_file_dir.$filename;
				} else {
					$body .= "Error moving file to local directory $uploaded_file_dir.  Check permissions on directory<br>";
				}
			}
			// now upload the file to every mirror in list
			// get all mirros first
			$sync_table = $table_prefix . "sync";
			$sync_mir_query = "SELECT * FROM `$sync_table` WHERE 1";
			$sync_mir_result = mysql_query($sync_mir_query);
			$index=0; // for array
			while($mir_array=mysql_fetch_array($sync_mir_result)){
				foreach($mir_array as $key => $val){
					$sync_array[$index][$key]=$val;
				}
				$index++;
			}
			// use for loop to send
			for($i=0;$i<count($sync_array);$i++){
				switch ($sync_array[$i][sync_type]){
					case 1:
						// ftp style, use function
						// add successes/failures to body
						$error=ftp_update_file($sync_array[$i][sync_host],$sync_array[$i][sync_login],$sync_array[$i][sync_pass],$local_file,$sync_array[$i][sync_dir].$filename);
						if($error==""){
							$body .= "$filename successfully added to ".$sync_array[$i][sync_host]."<br>";
						} else {
							$body .= "Error adding file to ".$sync_array[$i][sync_host]."<br>".$error."<br>";
						}
						break;
					case 2:
						// post style.  post the data
						if($socket = fsockopen($sync_array[$i][sync_host],80,$soc_err_no,$soc_err,'10')){
							// connected
							// establish header and send password
							$host = $sync_array[$i][sync_host];
							$dir = $sync_array[$i][sync_dir];
							$pass = $sync_array[$i][sync_pass];
							$pass_len = strlen($pass);
							$filename_len=strlen($filename);
							
							// content for the password is constructed.
							// now try to send the file.  first will try to determine
							// mime type
							$file_mime = mime_content_type($local_file);
							// now length
							$file_len = filesize($local_file);
							// hash the file
							$file_hash = md5_file($local_file);
							// need that length
							$hash_len = strlen($file_hash);
							// now read the file
							$file_handle = fopen($local_file,'r');
							$file_contents = fread($file_handle,$file_len);
							fclose($file_handle);
							// need total length
							$total_length = $pass_len + $filename_len + $hash_len + $file_len;
							// now build the header
							
							// contributed by peyox
							$headers  = "POST $dir HTTP/1.1\r\n";
$headers .= "Accept: */*\r\n";
$headers .= "Content-Type: multipart/form-data; boundary=---------------------------7d52521ec0a0a\r\n";
$headers .= "Host: $host\r\n";
$headers .= "Connection: Keep-Alive\r\n";

$postVars  = "-----------------------------7d52521ec0a0a\r\n";
$postVars .= "Content-Disposition: form-data; name=\"pass\"\r\n\r\n";
$postVars .= $pass."\r\n";
$postVars .= "-----------------------------7d52521ec0a0a\r\n";
$postVars .= "Content-Disposition: form-data; name=\"filename\"\r\n\r\n";
$postVars .= $filename."\r\n";
$postVars .= "-----------------------------7d52521ec0a0a\r\n";
$postVars .= "Content-Disposition: form-data; name=\"hash\"\r\n\r\n";
$postVars .= $file_hash."\r\n";
$postVars .= "-----------------------------7d52521ec0a0a\r\n";
$postVars .= "Content-Disposition: form-data; name=\"file\"; filename=\"$local_file\"\r\n";
$postVars .= "Content-Length: $file_len\r\n";
$postVars .= "Content-Type: $file_mime\r\n\r\n";
$postVars .= $file_contents."\r\n";
$postVars .= "-----------------------------7d52521ec0a0a--\r\n\r\n";

$total_length = strlen($postVars);
$headers .= "Content-Length: $total_length\r\n\r\n";

$content_string = $headers.$postVars;
// end section by peyox
							// now write this to the remote server
							fwrite($socket,$content_string);
							// get error code
							$response=fread($socket,2048); // 1024 should be enough
							$error_code=substr($response,strrpos($response,'RESPONSE: ')+10,1);
							print $error_code;
							// close socket
							fclose($socket);
							// display the results
							switch ($error_code){
								case '0':
									// all was good
									$body .= "File synced via post to ".$sync_array[$i][sync_host]."<br>";
									break;
								case '1':
									// failed hash
									$body .= "Remote file hash failed.  Maybe timeout for transfer to ".$sync_array[$i][sync_host].".<br>";
									break;
								case '2':
									// failed move
									$body .= "File failed to move directories on remote server.  Admin notified if set.  server ".$sync_array[$i][sync_host].".<br>";
									break;
								case '3':
									// upload all good, but admin will verify
									$body .= "File synced via post to ".$sync_array[$i][sync_host]." but admin still needs to verify and move the file.";
									break;
									default:
										$body .= "Error posting to ".$sync_array[$i][sync_host]."<br>";
										break;
							}
							
						} else {
							$body .= "Could not connect to ".$sync_array[$i][sync_host].":<br>$soc_err_no: $soc_err<br>";
						}
						break;
				}
			}
						
		} else {
			//default to show:  show link to add file, display all sync mirrors
			$sync_table = $table_prefix . "sync";
			$all_sel_query = "SELECT * FROM `$sync_table` WHERE 1";
			$all_sel_result = mysql_query($all_sel_query);
			if (mysql_num_rows($all_sel_result)<1){
				// no entries!
				$table = "<br><strong>No mirrors to syncronize in database</strong><br>";
			} else {
				// there is at least one entry.
				// define the table and the headings row
				
				// TODO: display current bw usage here
				$table_header = <<<EOTH
				<br>
				<table width="200px" cellspacing="1" cellpadding="1" border="1">
				<th>Mirror Host</th><th>Sync Type</th><th<th>Edit</th><th>Delete</th>
EOTH;
				// now loop and populate the table.  each row is one db row
				while ($row_array = mysql_fetch_array($all_sel_result)){
					$id = $row_array[id];
					$host = $row_array[sync_host];
					$type = $row_array[sync_type];
					// the following lines actually makes the row
					switch($type){
						case 1:
							// ftp style
							$type_word="FTP";
							break;
						case 2:
							$type_word="Post Script";
							break;
					}
					$rows .= <<<EOR
					<tr>
					<td>$host</td>
					<td>$type_word</td>
					<td><a href="$self?section=syncronize&action=edit_server&id=$id">Edit</a></td>
					<td><a href="$self?section=syncronize&action=del_server&id=$id">Delete</a></td>
					</tr>
EOR;
				}
				$table_footer = "</table><br>";
				// put the table together
				$table = $table_header . $rows . $table_footer;
			}
			// construct the page
			$body = <<<EOP
			<a href="$self">Index</a><br><br><br><br>
			Welcome to the administration section for syncronizing mirrors.<br>
			<a href="$self?section=syncronize&action=new_server">Click Here to add a new syncronizing mirror</a>.<br>
			<a href="$self?section=syncronize&action=add_file">Click Here to add a file to all the syncronization mirrors</a><br>
			<br>
			Below is a list of the current mirrors:<br>
			<br>
			$table
EOP;
		}
	} else {
		// default section where you can chose where to go
		$body = <<<EOP
		Welcome admin.<br>
		<br>
		What would you like to manage?<br>
		<a href="$self?section=mirrors">Mirrors</a><br>
		<a href="$self?section=files">Files</a><br>
		<a href="$self?section=config">Configuration</a><br>
		<a href="$self?section=syncronize">Synconization Mirrors</a>
EOP;
	}
}elseif (isset($_POST[submit])){
	// trying to log in,  verify
	if ($_POST[login]==$ADMIN_LOGIN && hash_pw($_POST[pass])==$ADMIN_PASSWORD){
		// authenticated.  setting session cookie and redirecting
		
		// you can modify this as you please, but change the top if to
		// match if you do
		$_SESSION[login_term]="allowed";
		// redirect
		header("Location: $self\n\n");
		die(); // to insure headers are not set again
	} else {
		// not correct login
		$body = <<<EOP
		<strong>INCORRECT LOGIN</strong><br>
		Try again<br>
		<br>
		<form action="$self" method="post">
		Login:<br>
		<input type="text" name="login"><br>
		<br>
		Password:<br>
		<input type="password" name="pass"><br>
		<br>
		<input type="submit" name="submit" value="Submit">
		</form>
EOP;
	}
} else {
	// needs to log in.  show login form
	// this needs to be done rapidly, so it will look like crap
	$body = <<<EOP
	Welcome to the mirror admin page.<br>
	<br>
	Please login to continue:<br>
	<br>
	<form action="$self" method="post">
	Login:<br>
	<input type="text" name="login"><br>
	<br>
	Password:<br>
	<input type="password" name="pass"><br>
	<br>
	<input type="submit" name="submit" value="Submit">
	</form>
EOP;
}
echo $body;



?>
