<?php
/**
* functions.php
* file contains functions used by other
* parts of system.
* @author quad341
* @version 2005-04-08
**/

/**
* function that hashes the string for verification for 
* admin login
* @param string $password the password to be hashed
* @return string the hashed password
*/
function hash_pw($password){
	return strrev(md5("clink".$password));
}

/**
* function to update a file for file mirroring
* takes care of the ftp login, upload, and disconnect
* @param string $host the host to connect to
* @param string $login the ftp login to use
* @param string $pass the ftp password to use
* @param string $path_from the path to the file to upload
* @param string $path_to the path to upload the file to on the server
* @return mixed true if all uploaded, string error otherwise
*/
function ftp_update_file($host,$login,$pass,$path_from,$path_to){
	// initialize the connection
	$connection = ftp_connect($host);
	if (!$connection){
		// could not connect to host
		return "Could not connect to ftp server";
	}
	// login
	$ftp_login=ftp_login($connection,$login,$pass);
	if(!$ftp_login){
		return "Invalid login to server";
	}
	// try to upload
	$uploaded=ftp_put($connection,$path_to,$path_from,FTP_BINARY);
	if(!$uploaded){
		return "File upload failed";
	}
	// close connection
	ftp_close($connection);
	return true;
}
?>