<?php
/**
* Script for mirrors to recieve files from the host of the file mirror script
* @author quad341
* @version 2005-04-10
**/

/**
* variable to determine the password to allow upload
* ADMIN: ensure the mirror host knows this password
* MIRROR HOST: feel free to change this password before distribution to save time
* @var string Password to allow file uploads
**/
$PASSWORD="cryptic_password";

/**
* variable to determine where files are moved to
* ADMIN: set this to the reletive or absolute path to where you want the files (must be writable by php)
*        and make sure the mirror host links to the correct folder then. blank is current folder
**/
$DIRECTORY="";

/**
* variable that determines if the admin is emailed to move the file upon upload
* if true, admin is emailed upon upload, false they are not
* usually upload to a directory without read or execute access initially if you want
* to verify
* @var bool True of false to email admin on upload
**/
$CONFIRM_UPLOAD=false;

/**
* variable that determines the admin email for notifying on upload if above variable is true
* and also email that is notified if the file cannot be moved to directory
* set to blank "" or false if you do no ever want to be notified
* @var string Email of admin to notify
**/
$ADMIN_EMAIL="";

if($_POST[pass]==$PASSWORD){
	// upload file
	$local_file=$_FILES[file][tmp_name];
	$filename = $_POST[filename];
	$hash = $_POST[hash];
	if($hash != md5_file($local_file)){
		// failed hash, error code 1
		die('RESPONSE: 1');
	}
	// you could check if this works and ouput if it does.  currently does not
	if(move_uploaded_file($local_file,$DIRECTORY.$filename)){
		if($CONFIRM_UPLOAD){
			// admin must confirm, error code 3
			mail($ADMIN_EMAIL,'File Uploaded',"File $filename was just uploaded, please verify and move to proper directory");
			die('RESPONSE: 3');
		} else {
			// all good, error code 0
			die('RESPONSE: 0');
		}
	} else {
		// failed to move, error code 2
		die('RESPONSE: 2');
		if($ADMIN_EMAIL){
			mail($ADMIN_EMAIL,'Failed Upload',"File $filename just failed to upload.  check permissions on $DIRECTORY.");
		}
	}
}
header("HTTP/1.0 404 Not Found");
die();
?>