<?php
/**************
* mirror_download.php
* @author quad341
* the download script
* @version 2005-04-01...it's april fools day... off to google
****************/
$self = $_SERVER[PHP_SELF];
require_once "mirror_config.php";
// to determine which file to give, an id must be set.  check
if (!(isset($_GET[id]))){
	// no id specified.  if $show_file_list = true, set in admin or config,
	// will display a list of all the files, else redirects by default
	if($show_file_list==true){
		// get all files and display
		$files_table = $table_prefix . "files";
		$all_files_query = "SELECT * FROM `$files_table` WHERE 1";
		$all_files_result = mysql_query($all_files_query);
		if(mysql_num_rows($all_files_result)<1){
			// no files, DISPLAY this
			$body = "There are currently no files to download";
		} else {
			// there is at least one file
			// DISPLAY this
			$body = "This is the current list of all the files available:<br>
			<br>";
			// now loop through all entries
			while ($file_array = mysql_fetch_array($all_files_result)){
				$body .= "<a href=\"$self?id=".$file_array[id]."\">".$file_array[filename]."</a><br>";
			}
		}
	} else {
		// this redirects by default.  you may want to
		// just have this display an error message instead
		$site = $_SERVER[HTTP_HOST];
		header("Location: http://$site\n\n");
		die(); // stop other headers
	}
} else {
	// this isn't as simple as you might think.  let's outline the steps
	/*
		Steps:
		1) look up filename and file_size
		2) look up mirror list
		3) check which mirror was used last, then increment
		4) check if by using the bytes transfered from mirror + filesize > bw limit
		5) if not, metarefresh and show link
		- or -
		5) if so, increment to next mirror and go to 4.  make sure not to loop infinitely
		6) if no mirrors have bandwidth, die with error
	*/
	// simple, huh?  let's go
	$id = $_GET[id];
	// look up the file
	$file_table = $table_prefix . "files";
	$sel_query = "SELECT * FROM `$file_table` WHERE `id`='$id'";
	$sel_result = mysql_query($sel_query);
	if(mysql_num_rows($sel_result)<1){
		// no file, error
		die("Invalid id.");
	} else {
		// it's good
		while($file_array = mysql_fetch_array($sel_result)){
			$filename = $file_array[filename];
			$filesize = $file_array[file_size];
		}
	}
	// step 1 done.  now for step 2
	// look up all mirrors.  make sure there are mirrors
	$mirrors_table = $table_prefix . "mirrors";
	$mir_sel_query = "SELECT * FROM `$mirrors_table` WHERE 1";
	$mir_sel_result = mysql_query($mir_sel_query);
	if(mysql_num_rows($mir_sel_result)<1){
		// error, no mirrors
		die("There are no mirrors.");
	} else {
		// we're going to make an array out of these
		$i = 0;
		while($mir_sel_array = mysql_fetch_array($mir_sel_result)){
			$mirror_array[$i][id]=$mir_sel_array[id];
			$mirror_array[$i][name]=$mir_sel_array[name];
			$mirror_array[$i][base_url]=$mir_sel_array[base_url];
			$mirror_array[$i][bw_limit]=$mir_sel_array[max_bw];
			$i++; // increment i so the array works
		}
	}
	// step 2 done.  now for step 3.  let's describe this first
	/*
		In order to keep track of the last mirror used and the amount of
		data sent through that mirror, a database is created every month.
		the first entry is always going to hold the last used mirror's id
		and array id (respectively).  the array id is used to try to find this spot in the
		array faster (if the mirror list only gets bigger, this will always find
		the entry first).  if it can no longer find this mirror, it will
		use whatever is at that array position or then spot 0.
		
		the other rows in the database contain the mirror id and the
		bytes transferred.
		
		rows and databases are created if they don't exist
	*/
	// to get the table name we need to know what YYYY-mm is (all numbers)
	$month = date('Y-m',time());
	$month_table = $table_prefix . $month;
	// now try to get the last used mirror
	$last_used_query = "SELECT * FROM `$month_table` WHERE `id`='1'";
	$last_used_result = mysql_query($last_used_query);
	if ($last_used_result){
		// table exists.  if table exists, this row existed
		while($last_used_row = mysql_fetch_row($last_used_result)){
			$last_mirror_id = $last_used_row[1];
			$last_mirror_ary_pt = $last_used_row[2];
		}
		// it knows the information.  now try to find the mirror to use...
		// start by locating this mirror if possible
		$found = false;
		for ($j=0;$j<count($mirror_array);$j++){
			// j is terminator and also used to go through array
			if($mirror_array[($last_mirror_ary_pt+$j)%count($mirror_array)][id]==$last_mirror_id){
				// found it
				$found = true;
				$last_mirror_ary_pt = ($last_mirror_ary_pt+$j)%count($mirror_array);
				break;
			}
		}
		if($found){
			// the mirror was found.  try to use the next array entry.
			// make sure not to infinitely loop
			$can_dl=false;
			for ($k=0;$k<count($mirror_array);$k++){
				// we're going to use $k +1 here to always move ahead
				
				// we need to find the next entry's id, select that row and
				// look at the bw_used.  make sure it's ok to download
				// if so, break, use it.  if not,  move on
				$tmp_mir_id = $mirror_array[($last_mirror_ary_pt+$k+1)%count($mirror_array)][id];
				$bw_sel_query = "SELECT `bw_used` FROM `$month_table` WHERE `mir_id`='$tmp_mir_id'";
				$bw_sel_result = mysql_query($bw_sel_query);
				if(mysql_num_rows($bw_sel_result)<1){
					// row currently not present.  good.
					// that means no downloads from it.  set bw_used to 0
					$bw_used=0;
					$no_row=true; // for updating later
				} else {
					$no_row=false;
					while($bw_row = mysql_fetch_row($bw_sel_result)){
						$bw_used=$bw_row[0];
					}
				}
				// check if we can download
				$total_bw=$filesize+$bw_used;
				if($total_bw<$mirror_array[($last_mirror_ary_pt+$k+1)%count($mirror_array)][bw_limit]){
					// we can.  update the bw_used, then set up the page
					if ($no_row){
						// we have to insert instead up updating
						$ins_query = "INSERT INTO `$month_table` (`mir_id`,`bw_used`) VALUES ('$tmp_mir_id','$total_bw')";
						$ins_result = mysql_query($ins_query);
						// not going to verify this because it has no reason to fail and we don't want users to see it
						// if you want to modify it to verify, i suggest checking if not true.
						// if not true, email yourself and kill the script without showing the mysql_error() publically
					} else {
						// update
						$upd_query = "UPDATE `$month_table` SET `bw_used`='$total_bw' WHERE `mir_id`='$tmp_mir_id'";
						$upd_result=mysql_query($upd_query);
						// not verifying.  see explanation in if section
					}
					// now update the array index and mirror id
					$index = ($last_mirror_ary_pt+$k+1)%count($mirror_array);
					$base_upd_query = "UPDATE `$month_table` SET `mir_id`='$tmp_mir_id',`bw_used`='$index' WHERE `id`='1'";
					$base_upd_result = mysql_query($base_upd_query);
					// again, no verify.  see above
					
					// now to set up the page.
					// making the link
					$link = $mirror_array[$index][base_url] . $filename;
					$mirror_name = $mirror_array[$index][name];
					/**********************
					* DISPLAY SECTION
					*************************/
					// edit below to change how it looks.  i'm using heredoc style so it's simpler to edit
					// this part is just for displaying the list of mirrors
					if($show_mirrors_list){
						// header for table
						$t_header = "The following site have kindly offered to mirror this file<br>
						<table width=\"30%\" cellpadding=\"0\" cellspacing=\"1\" border=\"1\">
						<th align=\"left\">Name</th><th align=\"left\">Homepage</th>";
						// now this will loop through all mirrors and display a link to them
						for($q=0;$q<count($mirror_array);$q++){
							// table row
							$name = $mirror_array[$q][name];
							$url_array = parse_url($mirror_array[$q][base_url]);
							$hostname = $url_array[scheme]."://".$url_array[host];
							$t_body="
							<tr>
							<td>$name</td><td><a href=\"$hostname\">$hostname</a></td>
							</tr>";
						}
						// footer for table
						$t_foot = "</table>";
						$table = $t_header . $t_body . $t_foot;
					} else {
						$table = "";
					}
					$body = <<<EOF
					<html>
					<head>
					<title>Downloading $filename from $mirror_name</title>
					<meta http-equiv="refresh" content="5;URL=$link">
					</head>
					<body>
					$filename is being served to you by <strong>$mirror_name</strong><br>
					<br>
					Your download should start in 5 seconds.<br>
					If it does not,  please download from the following link: <a href="$link">$link</a><br>
					*You may have to right click the link and select "save as..."<br>
					<br>
					$table
					</body>
					</html>"
EOF;
					/*******************
					* END DISPLAY SECTION
					*******************/
					$can_dl=true;
					break;
				}
				// else, increment and try again
			}
			if (!$can_dl){
				// can't download.  show your sorry message
				/***************
				* DISPLAY: NO BW MSG
				*************/
				$body = <<<EOF
				<html>
				<head>
				<title>Cannot download $filename</title>
				</head>
				
				<body>
				We are sorry, but no mirror can support your download.<br>
				To help this, consider <a href="donate.html">donating</a> to help server fees.<br>
				<br>
				You can also try to <a href="http://google.com/search?q=$filename+download">search for a download</a>.
				</body>
				</html>
EOF;
				/******************
				* END DISPLAY
				*******************/
			}
		} else {
			// mirror not found, try to use that entry in the array or original
			if(isset($mirror_array[$last_mirror_ary_pt])){
				// it exists, try to use this id
				$can_dl=false;
				for ($k=0;$k<count($mirror_array);$k++){
					// we're going to use $k +1 here to always move ahead
					
					// we need to find the next entry's id, select that row and
					// look at the bw_used.  make sure it's ok to download
					// if so, break, use it.  if not,  move on
					$tmp_mir_id = $mirror_array[($last_mirror_ary_pt+$k)%count($mirror_array)][id];
					$bw_sel_query = "SELECT `bw_used` FROM `$month_table` WHERE `mir_id`='$tmp_mir_id'";
					$bw_sel_result = mysql_query($bw_sel_query);
					if(mysql_num_rows($bw_sel_result)<1){
						// row currently not present.  good.
						// that means no downloads from it.  set bw_used to 0
						$bw_used=0;
						$no_row=true; // for updating later
					} else {
						$no_row=false;
						while($bw_row = mysql_fetch_row($bw_sel_result)){
							$bw_used=$bw_row[0];
						}
					}
					// check if we can download
					$total_bw=$filesize+$bw_used;
					if($total_bw<$mirror_array[($last_mirror_ary_pt+$k)%count($mirror_array)][bw_limit]){
						// we can.  update the bw_used, then set up the page
						if ($no_row){
							// we have to insert instead up updating
							$ins_query = "INSERT INTO `$month_table` (`mir_id`,`bw_used`) VALUES ('$tmp_mir_id','$total_bw')";
							$ins_result = mysql_query($ins_query);
							// not going to verify this because it has no reason to fail and we don't want users to see it
							// if you want to modify it to verify, i suggest checking if not true.
							// if not true, email yourself and kill the script without showing the mysql_error() publically
						} else {
							// update
							$upd_query = "UPDATE `$month_table` SET `bw_used`='$total_bw' WHERE `mir_id`='$tmp_mir_id'";
							$upd_result=mysql_query($upd_query);
							// not verifying.  see explanation in if section
						}
						// now update the array index and mirror id
						$index = ($last_mirror_ary_pt+$k)%count($mirror_array);
						$base_upd_query = "UPDATE `$month_table` SET `mir_id`='$tmp_mir_id',`bw_used`='$index' WHERE `id`='1'";
						$base_upd_result = mysql_query($base_upd_query);
						// again, no verify.  see above
						
						// now to set up the page.
						// making the link
						$link = $mirror_array[$index][base_url] . $filename;
						$mirror_name = $mirror_array[$index][name];
						/**********************
						* DISPLAY SECTION
						*************************/
						// edit below to change how it looks.  i'm using heredoc style so it's simpler to edit
						// this part is just for displaying the list of mirrors
					if($show_mirrors_list){
						// header for table
						$t_header = "The following site have kindly offered to mirror this file<br>
						<table width=\"30%\" cellpadding=\"0\" cellspacing=\"1\" border=\"1\">
						<th align=\"left\">Name</th><th align=\"left\">Homepage</th>";
						// now this will loop through all mirrors and display a link to them
						for($q=0;$q<count($mirror_array);$q++){
							// table row
							$name = $mirror_array[$q][name];
							$url_array = parse_url($mirror_array[$q][base_url]);
							$hostname = $url_array[scheme]."://".$url_array[host];
							$t_body="
							<tr>
							<td>$name</td><td><a href=\"$hostname\">$hostname</a></td>
							</tr>";
						}
						// footer for table
						$t_foot = "</table>";
						$table = $t_header . $t_body . $t_foot;
					} else {
						$table = "";
					}
					$body = <<<EOF
					<html>
					<head>
					<title>Downloading $filename from $mirror_name</title>
					<meta http-equiv="refresh" content="5;URL=$link">
					</head>
					<body>
					$filename is being served to you by <strong>$mirror_name</strong><br>
					<br>
					Your download should start in 5 seconds.<br>
					If it does not,  please download from the following link: <a href="$link">$link</a><br>
					*You may have to right click the link and select "save as..."<br>
					<br>
					$table
					</body>
					</html>"
EOF;
						/*******************
						* END DISPLAY SECTION
						*******************/
						$can_dl=true;
						break;
					}
					// else, increment and try again
				}
				if (!$can_dl){
					// can't download.  show your sorry message
					/***************
					* DISPLAY: NO BW MSG
					*************/
					$body = <<<EOF
					<html>
					<head>
					<title>Cannot download $filename</title>
					</head>
					
					<body>
					We are sorry, but no mirror can support your download.<br>
					To help this, consider <a href="donate.html">donating</a> to help server fees.<br>
					<br>
					You can also try to <a href="http://google.com/search?q=$filename+download">search for a download</a>.
					</body>
					</html>
EOF;
					/******************
					* END DISPLAY
					*******************/
				}
			} else {
				// it's gotten smaller, so let's just start at zero of array index
				$can_dl=false;
				for ($k=0;$k<count($mirror_array);$k++){
					// we're going to use $k +1 here to always move ahead
					
					// we need to find the next entry's id, select that row and
					// look at the bw_used.  make sure it's ok to download
					// if so, break, use it.  if not,  move on
					$tmp_mir_id = $mirror_array[$k][id];
					$bw_sel_query = "SELECT `bw_used` FROM `$month_table` WHERE `mir_id`='$tmp_mir_id'";
					$bw_sel_result = mysql_query($bw_sel_query);
					if(mysql_num_rows($bw_sel_result)<1){
						// row currently not present.  good.
						// that means no downloads from it.  set bw_used to 0
						$bw_used=0;
						$no_row=true; // for updating later
					} else {
						$no_row=false;
						while($bw_row = mysql_fetch_row($bw_sel_result)){
							$bw_used=$bw_row[0];
						}
					}
					// check if we can download
					$total_bw=$filesize+$bw_used;
					if($total_bw<$mirror_array[$k][bw_limit]){
						// we can.  update the bw_used, then set up the page
						if ($no_row){
							// we have to insert instead up updating
							$ins_query = "INSERT INTO `$month_table` (`mir_id`,`bw_used`) VALUES ('$tmp_mir_id','$total_bw')";
							$ins_result = mysql_query($ins_query);
							// not going to verify this because it has no reason to fail and we don't want users to see it
							// if you want to modify it to verify, i suggest checking if not true.
							// if not true, email yourself and kill the script without showing the mysql_error() publically
						} else {
							// update
							$upd_query = "UPDATE `$month_table` SET `bw_used`='$total_bw' WHERE `mir_id`='$tmp_mir_id'";
							$upd_result=mysql_query($upd_query);
							// not verifying.  see explanation in if section
						}
						// now update the array index and mirror id
						$base_upd_query = "UPDATE `$month_table` SET `mir_id`='$tmp_mir_id',`bw_used`='$k' WHERE `id`='1'";
						$base_upd_result = mysql_query($base_upd_query);
						// again, no verify.  see above
						
						// now to set up the page.
						// making the link
						$link = $mirror_array[$index][base_url] . $filename;
						$mirror_name = $mirror_array[$index][name];
						/**********************
						* DISPLAY SECTION
						*************************/
						// edit below to change how it looks.  i'm using heredoc style so it's simpler to edit
						// this part is just for displaying the list of mirrors
					if($show_mirrors_list){
						// header for table
						$t_header = "The following site have kindly offered to mirror this file<br>
						<table width=\"30%\" cellpadding=\"0\" cellspacing=\"1\" border=\"1\">
						<th align=\"left\">Name</th><th align=\"left\">Homepage</th>";
						// now this will loop through all mirrors and display a link to them
						for($q=0;$q<count($mirror_array);$q++){
							// table row
							$name = $mirror_array[$q][name];
							$url_array = parse_url($mirror_array[$q][base_url]);
							$hostname = $url_array[scheme]."://".$url_array[host];
							$t_body="
							<tr>
							<td>$name</td><td><a href=\"$hostname\">$hostname</a></td>
							</tr>";
						}
						// footer for table
						$t_foot = "</table>";
						$table = $t_header . $t_body . $t_foot;
					} else {
						$table = "";
					}
					$body = <<<EOF
					<html>
					<head>
					<title>Downloading $filename from $mirror_name</title>
					<meta http-equiv="refresh" content="5;URL=$link">
					</head>
					<body>
					$filename is being served to you by <strong>$mirror_name</strong><br>
					<br>
					Your download should start in 5 seconds.<br>
					If it does not,  please download from the following link: <a href="$link">$link</a><br>
					*You may have to right click the link and select "save as..."<br>
					<br>
					$table
					</body>
					</html>"
EOF;
						/*******************
						* END DISPLAY SECTION
						*******************/
						$can_dl=true;
						break;
					}
					// else, increment and try again
				}
				if (!$can_dl){
					// can't download.  show your sorry message
					/***************
					* DISPLAY: NO BW MSG
					*************/
					$body = <<<EOF
					<html>
					<head>
					<title>Cannot download $filename</title>
					</head>
					
					<body>
					We are sorry, but no mirror can support your download.<br>
					To help this, consider <a href="donate.html">donating</a> to help server fees.<br>
					<br>
					You can also try to <a href="http://google.com/search?q=$filename+download">search for a download</a>.
					</body>
					</html>
EOF;
					/******************
					* END DISPLAY
					*******************/
				}
			}
		}
	} else {
		// no table present.  create table, add first row and try to download
		// using same procedure as above
		//create table
		$create_table_query = "CREATE TABLE `$month_table` (
			`id` INT AUTO_INCREMENT PRIMARY KEY NOT NULL,
			`mir_id` INT NOT NULL,
			`bw_used` varchar(32) NOT NULL
			)";
		$create_table_result = mysql_query($create_table_query); // no verify.  explained above
		// find the array entry to download starting at 0
		$can_dl=false;
		for ($k=0;$k<count($mirror_array);$k++){
			// we're going to use $k +1 here to always move ahead
			
			// we need to find the next entry's id, select that row and
			// look at the bw_used.  make sure it's ok to download
			// if so, break, use it.  if not,  move on
			$tmp_mir_id = $mirror_array[$k][id];
			$bw_sel_query = "SELECT `bw_used` FROM `$month_table` WHERE `mir_id`='$tmp_mir_id'";
			$bw_sel_result = mysql_query($bw_sel_query);
			if(mysql_num_rows($bw_sel_result)<1){
				// row currently not present.  good.
				// that means no downloads from it.  set bw_used to 0
				$bw_used=0;
				$no_row=true; // for updating later
			} else {
				$no_row=false;
				while($bw_row = mysql_fetch_row($bw_sel_result)){
					$bw_used=$bw_row[0];
				}
			}
			// check if we can download
			$total_bw=$filesize+$bw_used;
			if($total_bw<$mirror_array[$k][bw_limit]){
				// we can.  update the bw_used, then set up the page
				if ($no_row){
					// we have to insert instead up updating
					$ins_query = "INSERT INTO `$month_table` (`mir_id`,`bw_used`) VALUES ('$tmp_mir_id','$total_bw')";
					$ins_result = mysql_query($ins_query);
					// not going to verify this because it has no reason to fail and we don't want users to see it
					// if you want to modify it to verify, i suggest checking if not true.
					// if not true, email yourself and kill the script without showing the mysql_error() publically
				} else {
					// update
					$upd_query = "UPDATE `$month_table` SET `bw_used`='$total_bw' WHERE `mir_id`='$tmp_mir_id'";
					$upd_result=mysql_query($upd_query);
					// not verifying.  see explanation in if section
				}
				// now update the array index and mirror id
				$base_upd_query = "UPDATE `$month_table` SET `mir_id`='$tmp_mir_id',`bw_used`='$k' WHERE `id`='1'";
				$base_upd_result = mysql_query($base_upd_query);
				// again, no verify.  see above
				
				// now to set up the page.
				// making the link
				$link = $mirror_array[$index][base_url] . $filename;
				$mirror_name = $mirror_array[$index][name];
				/**********************
				* DISPLAY SECTION
				*************************/
				// edit below to change how it looks.  i'm using heredoc style so it's simpler to edit
				// this part is just for displaying the list of mirrors
					if($show_mirrors_list){
						// header for table
						$t_header = "The following site have kindly offered to mirror this file<br>
						<table width=\"30%\" cellpadding=\"0\" cellspacing=\"1\" border=\"1\">
						<th align=\"left\">Name</th><th align=\"left\">Homepage</th>";
						// now this will loop through all mirrors and display a link to them
						for($q=0;$q<count($mirror_array);$q++){
							// table row
							$name = $mirror_array[$q][name];
							$url_array = parse_url($mirror_array[$q][base_url]);
							$hostname = $url_array[scheme]."://".$url_array[host];
							$t_body="
							<tr>
							<td>$name</td><td><a href=\"$hostname\">$hostname</a></td>
							</tr>";
						}
						// footer for table
						$t_foot = "</table>";
						$table = $t_header . $t_body . $t_foot;
					} else {
						$table = "";
					}
					$body = <<<EOF
					<html>
					<head>
					<title>Downloading $filename from $mirror_name</title>
					<meta http-equiv="refresh" content="5;URL=$link">
					</head>
					<body>
					$filename is being served to you by <strong>$mirror_name</strong><br>
					<br>
					Your download should start in 5 seconds.<br>
					If it does not,  please download from the following link: <a href="$link">$link</a><br>
					*You may have to right click the link and select "save as..."<br>
					<br>
					$table
					</body>
					</html>"
EOF;
				/*******************
				* END DISPLAY SECTION
				*******************/
				$can_dl=true;
				break;
			}
			// else, increment and try again
		}
		if (!$can_dl){
			// can't download.  show your sorry message
			/***************
			* DISPLAY: NO BW MSG
			*************/
			$body = <<<EOF
			<html>
			<head>
			<title>Cannot download $filename</title>
			</head>
			
			<body>
			We are sorry, but no mirror can support your download.<br>
			To help this, consider <a href="donate.html">donating</a> to help server fees.<br>
			<br>
			You can also try to <a href="http://google.com/search?q=$filename+download">search for a download</a>.
			</body>
			</html>
EOF;
			/******************
			* END DISPLAY
			*******************/
		}
	}
}
print $body;
?>
